/* Copyright (C) 1996,1997,1998,1999 by Salvador E. Tropea (SET),
   see copyrigh file for details */
#ifndef PATHTOOL_H_INCLUDED
#define PATHTOOL_H_INCLUDED
int   edTestForFile(const char *name);
char *ExpandFileNameToThePointWhereTheProgramWasLoaded(const char *s);
int   FindFile(const char * name,char * & fullName);
char *ReplaceExtention(char *name, char *ext, char *old);
int   DeleteWildcard(char *mask);
char *GetPathRelativeToRunPoint(char *dest, const char *binReplace, char *file);
void  SetReferencePath(char *orig);
char *RedirectStdErrToATemp(int &StdErrOri,int &StdErrNew);
char *ExpandFileNameToUserHome(const char *s);
int  FileCopy(const char *orig, const char *dest);

inline
char *ExpandHome(const char *s)
{
 return ExpandFileNameToThePointWhereTheProgramWasLoaded(s);
}

#ifdef __DJGPP__
// In DOS is like the load
#define ExpandHomeSave(a) ExpandHome(a)
#else
// In Linux we can't write in the share so that's a fixed expand to
// the user's home
#define ExpandHomeSave(a) ExpandFileNameToUserHome(a)
#endif
#endif
