/* Copyright (C) 1996,1997,1998,1999 by Salvador E. Tropea (SET),
   see copyrigh file for details */
class TDskWinEditor : public TDskWin
{
public:

 TDskWinEditor(TCEditWindow *EdW,int Num) : edw(EdW), number(Num)
        { type=dktEditor; CanBeSaved=1; };
 ~TDskWinEditor();

 int  GoAction(ccIndex i);
 int  DeleteAction(ccIndex i);
 char *GetText(char *dest, short maxLen);
 int  Compare(void *p,int t) { return (t==dktEditor) && (p==edw); };

 TCEditWindow *edw;
 int number;

 void write( opstream& );
 void *read(ipstream& );

 const char *streamableName() const
     { return name; }

protected:

 TDskWinEditor( StreamableInit ) { type=dktEditor; CanBeSaved=1; };

public:

 static const char *name;
 static TStreamable *build();
};

inline ipstream& operator >> ( ipstream& is, TDskWinEditor& cl )
    { return is >> (TStreamable&)cl; }
inline ipstream& operator >> ( ipstream& is, TDskWinEditor*& cl )
    { return is >> (void *&)cl; }

inline opstream& operator << ( opstream& os, TDskWinEditor& cl )
    { return os << (TStreamable&)cl; }
inline opstream& operator << ( opstream& os, TDskWinEditor* cl )
    { return os << (TStreamable *)cl; }

