/* Copyright (C) 1996,1997,1998,1999 by Salvador E. Tropea (SET),
   see copyrigh file for details */
class TEditorProjectWindow;

class TDskWinPrj : public TDskWin
{
public:

 TDskWinPrj(char *File);
 ~TDskWinPrj();

 int  GoAction(ccIndex i);
 int  DeleteAction(ccIndex i);
 char *GetText(char *dest, short maxLen);
 int  Compare(void *,int t) { return (t==dktPrj); };

 TEditorProjectWindow *window;
 char *FileName;

 void Create(char *File, char *Node, Boolean TheOne=False);

 void write( opstream& os );
 void *read(ipstream& is);

 const char *streamableName() const
     { return name; }

protected:

 TDskWinPrj( StreamableInit ) { type=dktPrj; CanBeSaved=0; };

public:

 static const char *name;
 static TStreamable *build();
};

inline ipstream& operator >> ( ipstream& is, TDskWinPrj& cl )
    { return is >> (TStreamable&)cl; }
inline ipstream& operator >> ( ipstream& is, TDskWinPrj*& cl )
    { return is >> (void *&)cl; }

inline opstream& operator << ( opstream& os, TDskWinPrj& cl )
    { return os << (TStreamable&)cl; }
inline opstream& operator << ( opstream& os, TDskWinPrj* cl )
    { return os << (TStreamable *)cl; }
